<?php

namespace App\Exports;

use App\Models\TransitInventory;
use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\WithStyles;
use PhpOffice\PhpSpreadsheet\Worksheet\Worksheet;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;

class ExportTransitInventory implements FromCollection, WithHeadings, WithStyles, ShouldAutoSize{
    function __construct($slug) {
        $this->slug = $slug;
    }

    public function collection(){
        $user = new TransitInventory();
        $data = $user->export($this->slug);
        
        if($data == null){
            throw new \ErrorException('No Data Found!');
        }else{
            return $data;
        }
    }

    public function headings() :array{
        return ['Branch','Car Model','Car Varient','Exteriorcolor' ,'Interiorcolor','KIN Invoice Number','KIN Invoice Date', 'Manufacturing Year','Key number' ,'Engine number' , 'Vin number', 'EX Showroom price', 'Status','Purchase Price','KIN Margin','Fuel Type','Inventory Type','Offer Applicable','Remark'];
    }

    public function styles(Worksheet $sheet){
        return [1 => ['font' => ['bold' => true]]];
    }
}